// SIN PWM 3PHASE GENERATOR
// FREQ CARRIER 3KHz (Resolution 1000 quants)
// FREQ SINE 50Hz
// USED TIM1 + DMA + DMA BURST
// MSU USED STM32F405RG

static volatile unsigned int sindat[240];
unsigned int angl;
unsigned int i;
const float pi = 3.1416;

void main() {
// Calculate SIN Table 3 Phase -------------------------------------------------
     angl = 0;
 for (i=0; i<60; i++) {
      //sindat[4 * i] = i;
      angl = i * 6;
      sindat[4 * i] = 500 + 500 * (sin ((angl * pi)/180));
     }
 for (i=0; i<60; i++) {
      //sindat[(4 * i) + 1] = 100 + i;
      angl = (i * 6) + 120 ;
      sindat[(4 * i) + 1] = 500 + 500 * (sin ((angl * pi)/180));
     }
 for (i=0; i<60; i++) {
      //sindat[(4 * i) + 2] = 200 + i;
      angl = (i * 6) + 240;
      sindat[(4 * i) + 2] = 500 + 500 * (sin ((angl * pi)/180));
     }
// Timer 1 Setup ---------------------------------------------------------------
 GPIO_Alternate_Function_Enable (&_GPIO_MODULE_TIM1_CH1_PA8);                   //CONFIG CH1 PIN
 GPIO_Alternate_Function_Enable (&_GPIO_MODULE_TIM1_CH2_PA9);                   //CONFIG CH2 PIN
 GPIO_Alternate_Function_Enable (&_GPIO_MODULE_TIM1_CH3_PA10);                  //CONFIG CH3 PIN
 RCC_AHB1ENRbits.GPIOBEN =        1;                                            //ENABLR GPIOB CLOCK
 GPIOB_MODERbits.MODER13 =        0b10;                                         //CONFIG CH1 PIN AF
 GPIOB_MODERbits.MODER14 =        0b10;                                         //CONFIG CH2 PIN AF
 GPIOB_MODERbits.MODER15 =        0b10;                                         //CONFIG CH3 PIN AF
 GPIOB_AFRHbits.AFRH13   =        0b0001;                                       //SET AF1 (TIM1/TIM8)
 GPIOB_AFRHbits.AFRH14   =        0b0001;                                       //SET AF1 (TIM1/TIM8)
 GPIOB_AFRHbits.AFRH15   =        0b0001;                                       //SET AF1 (TIM1/TIM8)
 
 RCC_APB2ENRbits.TIM1EN =         1;                                            //Timer 1 Clock
 TIM1_CR1bits.CEN =               0;                                            //Disable Timer 1 counter
 TIM1_CR1bits.DIR_ =              0;                                            //Up Counting timer mode
 TIM1_CR1bits.CMS =               0b11;                                         //Center Aligned Mode

 TIM1_ARR =                       999;                                          //Load ARR register value
 TIM1_PSC =                       27;                                           //Load PSC register value
 TIM1_CR1bits.ARPE =              1;                                            //Load ARR register preload mode

 TIM1_CCMR1_Outputbits.OC1M =     0x6;                                          // Set CH1 pwm mode 1
 TIM1_CCMR1_Outputbits.OC2M =     0x6;                                          // Set CH1 pwm mode 1
 TIM1_CCMR2_Outputbits.OC3M =     0x6;                                          // Set CH1 pwm mode 1

 TIM1_CCMR1_Outputbits.OC1PE =    1;                                            //Load CCR1 register preload mode
 TIM1_CCMR1_Outputbits.OC2PE =    1;                                            //Load CCR2 register preload mode
 TIM1_CCMR2_Outputbits.OC3PE =    1;                                            //Load CCR3 register preload mode

 TIM1_CCERbits.CC1E =             1;                                            //Enable CCE1 output
 TIM1_CCERbits.CC1NE =            1;                                            //Enable CCE1N output
 TIM1_CCERbits.CC2E =             1;                                            //Enable CCE2 output
 TIM1_CCERbits.CC2NE =            1;                                            //Enable CCE2N output
 TIM1_CCERbits.CC3E =             1;                                            //Enable CCE1 output
 TIM1_CCERbits.CC3NE =            1;                                            //Enable CCE2N output

 TIM1_CCERbits.CC1P =             1;                                            //Active polarity CCE1 - low
 TIM1_CCERbits.CC1NP =            1;                                            //Active low polarity CCE1N - low
 TIM1_CCERbits.CC2P =             1;                                            //Active polarity CCE2 - low
 TIM1_CCERbits.CC2NP =            1;                                            //Active low polarity CCE2N - low
 TIM1_CCERbits.CC3P =             1;                                            //Active polarity CCE2 - low
 TIM1_CCERbits.CC3NP =            1;                                            //Active low polarity CCE2N - low

 TIM1_BDTRbits.OSSR =             1;                                            //Off-state selection for Run mode low
 TIM1_BDTRbits.DTG =              0x4D;                                         //Set Dead TIME 77ns
 TIM1_BDTRbits.MOE =              1;                                            //Set main output
 TIM1_CR1bits.ARPE =              1;                                            //Set timer auto reload
 TIM1_DIERbits.UDE =              1;                                            //Timer 1 DMA REQ Enable
 TIM1_CCR1 = 1;
 TIM1_CCR2 = 1;
 TIM1_CCR3 = 1;
 TIM1_CR1.CEN =                   1;                                            //Enable Timer 1 counter
                                                                                //Timer 1 Enable
//Timer 1 Setup DMA BURST ------------------------------------------------------
 TIM1_DCRbits.DBA =               0x0D;                                         // CCR1 Register Offset 0x0D
 TIM1_DCRbits.DBL =               0x03;                                         // 4 DMA Transaction as one
//DMA1 Setup -------------------------------------------------------------------
 RCC_AHB1ENRbits.DMA2EN =         1;                                            //DMA1 Clock
 DMA2_S5CR.EN =                   0;                                            //Stop DMA2 Streem5
 DMA2_S5PAR =                     (unsigned long)&TIM1_DMAR;                    //Pointer to TIM1_DMAR -> PAR
 DMA2_S5M0AR =                    (unsigned long)&sindat[0];                    //Pointer to &sindat[0] -> MAR0
 DMA2_S5NDTR =                    240;                                          //Data array element count
 //DMA2_S5CRbits.MSIZE =          1;                                            //MEM DATA Lenth 16bit (BUG IN COMPILER/DEF !!!!!)
 DMA2_S5CR.b13=                   1;                                            //MEM DATA Lenth 16bit
 //DMA2_S5CRbits.PSIZE=           1;                                            //PER DATA Lenth 16bit (BUG IN COMPILER/DEF !!!!!)
 DMA2_S5CR.b11=                   1;                                            //PER DATA Lenth 16bit
 //DMA2_S5CRbits.DIR =            1;                                            //DMA Direction Memory -> Pereph (BUG IN COMPILER/DEF !!!!!)
 DMA2_S5CR.b6=                    1;                                            //DMA Direction Memory -> Pereph
 DMA2_S5CRbits.CIRC =             1;                                            //Cycle mode
 DMA2_S5CRbits.MINC =             1;                                            //Memory address increment
 DMA2_S5CRbits.CHSEL =            6;                                            //DMA chanal select (TIM1_UP)
 DMA2_S5CRbits.MBURST =           1;                                            //DMA Burs 4 transaction by cicle
 DMA2_S5CRbits.EN =               1;                                            //Start DMA2 Streem5
//------------------------------------------------------------------------------
  while(1) {
  }
}
